---
title: Extensions
---

## Storages

| Gem                                                                                   | Description                                                                 |
| :----                                                                                 | :----------                                                                 |
| [shrine-aliyun-oss](https://github.com/zillou/shrine-aliyun-oss)                      | Storage using [Alibaba Cloud OSS](https://www.alibabacloud.com/product/oss) |
| [shrine-cloudinary](https://github.com/shrinerb/shrine-cloudinary)                    | Storage using [Cloudinary](https://cloudinary.com/)                         |
| [shrine-flickr](https://github.com/shrinerb/shrine-flickr)                            | Storage using [Flickr](https://flickr.com/)                                 |
| [shrine-fog](https://github.com/shrinerb/shrine-fog)                                  | Storage using [Fog](http://fog.io/)                                         |
| [shrine-ftp](https://github.com/ProjectResound/shrine-ftp)                            | Storage using an FTP server                                                 |
| [shrine-google_cloud_storage](https://github.com/renchap/shrine-google_cloud_storage) | Storage using [Google Cloud Storage](https://cloud.google.com/storage/)     |
| [shrine-gdrive_storage](https://github.com/edwardsharp/shrine-gdrive_storage)         | Storage using [Google Drive](https://www.google.com/drive/)                 |
| [shrine-gridfs](https://github.com/shrinerb/shrine-gridfs)                            | Storage using [Mongo GridFS](https://docs.mongodb.com/manual/core/gridfs/)  |
| [shrine-redis](https://github.com/dbongo/shrine-redis)                                | Storage using [Redis](https://redis.io/)                                    |
| [shrine-scp](https://github.com/jordanandree/shrine-scp)                              | Storage using `scp`                                                         |
| [shrine-sql](https://github.com/shrinerb/shrine-sql)                                  | Storage using an SQL database                                               |
| [shrine-uploadcare](https://github.com/shrinerb/shrine-uploadcare)                    | Storage using [Uploadcare](https://uploadcare.com)                          |
| [shrine-url](https://github.com/shrinerb/shrine-url)                                  | Storage for handling remote URLs                                            |
| [shrine-storage-you_tube](https://github.com/thedyrt/shrine-storage-you_tube)         | Storage using [YouTube](https://www.youtube.com/)                           |
| [shrine-webdav](https://github.com/funbox/shrine-webdav)                              | Storage using a [WebDAV](https://en.wikipedia.org/wiki/WebDAV) server       |

## Plugins

| Gem                                                                                         | Description                                                           |
| :----                                                                                       | :--------                                                             |
| [administrate-field-shrine](https://github.com/catsky/administrate-field-shrine)            | Plugin for [Administrate](https://github.com/thoughtbot/administrate) |
| [rails_admin_shrine](https://github.com/iquest/rails_admin_shrine)                          | Plugin for [RailsAdmin](https://github.com/sferik/rails_admin)        |
| [shrine-blurhash](https://github.com/renchap/shrine-blurhash)                               | Plugin for computing [Blurhash](https://blurha.sh/) on images         |
| [shrine-cloudimage](https://github.com/janklimo/shrine-cloudimage)                          | Plugin for [Cloudimage](https://www.cloudimage.io/)                   |
| [shrine-color](https://github.com/jnylen/shrine-color)                                      | Plugin for finding dominant color in an image                         |
| [shrine-configurable_storage](https://github.com/SleeplessByte/shrine-configurable_storage) | Plugin for lazy storage registration                                  |
| [shrine-content_addressable](https://github.com/SleeplessByte/shrine-content_addressable)   | Plugin for generating content addressable locations                   |
| [shrine-imgix](https://github.com/shrinerb/shrine-imgix)                                    | Plugin for [Imgix](https://www.imgix.com/)                            |
| [shrine-transloadit](https://github.com/shrinerb/shrine-transloadit)                        | Plugin for [Transloadit](https://transloadit.com/)                    |
| [shrine-aws-lambda](https://github.com/texpert/shrine-aws-lambda)                           | Plugin for [AWS Lambda](https://aws.amazon.com/lambda/)               |
| [hanami-shrine](https://github.com/katafrakt/hanami-shrine)                                 | Plugin for [Hanami](https://hanamirb.org/)                            |
| [shrine-mongoid](https://github.com/shrinerb/shrine-mongoid)                                | Plugin for [Mongoid](https://mongoid.org)                             |
| [shrine-rails](https://github.com/abepetrillo/shrine-rails)                                 | Plugin for [Rails](https://rubyonrails.org/)                          |
| [shrine-rom](https://github.com/shrinerb/shrine-rom)                                        | Plugin for [ROM](https://rom-rb.org/)                                 |
| [shrine-tus](https://github.com/shrinerb/shrine-tus)                                        | Plugin for [tus](https://tus.io) server integration                   |

## Libraries

| Gem                                                             | Description                                                                     |
| :-----                                                          | :-------                                                                        |
| [ckeditor](https://github.com/galetahub/ckeditor)               | Integration for [CKEditor](https://ckeditor.com/ckeditor-4/)                    |
| [faster_s3_url](https://github.com/jrochkind/faster_s3_url)     | Optimized generation of public and presigned AWS S3 GET URLs                    |
| [imgproxy](https://github.com/imgproxy/imgproxy.rb)             | Integration for [imgproxy](https://github.com/imgproxy/imgproxy)                |
| [rails_admin](https://github.com/sferik/rails_admin)            | Integration for [RailsAdmin](https://github.com/sferik/rails_admin)             |
| [uppy-s3_multipart](https://github.com/janko/uppy-s3_multipart) | Integration for [Uppy AWS S3 Multipart](https://uppy.io/docs/aws-s3-multipart/) |
