---
title: Shrine 1.4.2
---

Regressions
===========

* Version 1.4.1 introduced handling optimistic locking in ActiveRecord plugin,
  however the implementation wasn't stable and wouldn't work correctly in
  some cases, so we revert the behaviour as it was in version 1.4.0. Developers
  can still handle optimistic locking themselves inside background jobs.

* Version 1.4.1 introduced an instance filter of cached attachment in Sequel
  plugin, which makes the same record instance unupdateable after promoting,
  even when not using backgrounding, so we revert the behaviour as it was in
  version 1.4.0. This is only a problem if you're doing something with the
  record instance after updating attachment.

Improvements
============

* The Sequel plugin now doesn't rescue every `Sequel::Error` on promoting, it
  just rescues "Record not found" ones (in Sequel 4.28+ this is a
  `Sequel::NoExistingObject`, but prior to that was a generic `Sequel::Error`).
