---
title: Shrine 3.2.1
---

## Ruby 2.7 compatibility

* Shrine doesn't trigger [Ruby 2.7 warnings for separation of positional and
  keyword arguments][kwargs] anymore.

* Down 5.1.0 has been released, which resolves warnings and a `FrozenError`
  exception on Ruby 2.7. Shrine now requires at least this version of Down.

  If you're using `Down::Http`, make sure you're using http.rb 4.3.0 or newer.

* ImageProcessing 1.10.3 gem has been released which resolves Ruby 2.7 warnings
  as well. If you're using it for image processing, make sure to upgrade to
  this version:

  ```rb
  gem "image_processing", ">= 1.10.3", "< 2"
  ```

## Rack 2.1 compatibility

* The `derivation_endpoint` plugin now uses `Rack::Files` on Rack 2.1 or newer.

## Other improvements 

* The `S3#open` method now handles empty S3 objects.

[kwargs]: https://www.ruby-lang.org/en/news/2019/12/12/separation-of-positional-and-keyword-arguments-in-ruby-3-0/
